/*
 . startcd.narod.ru
*/

//***************************************************************
// This code is distributed under the GNU Public License
//		which can be found at http://www.gnu.org/licenses/gpl.txt
//***************************************************************


//v3.07   ==1   
//v3.05       
//v3.04     (OCR2<220)
//v3.03 add low pwm 6476
//v3.02 ,   
//v3.01       .
//v3   
//v2.12  
//v2.11 
//v2.10  
/*
3 
)
) -  
)  -  
    -     
 2  -      
   -      .
	 - 
	  + 
	   .
        9,59
    99,0     0,1 
  ,          
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */
#include <avr/pgmspace.h>


#include "term_fi.h"
#include "table.h"

/*
4000000 meg 
*/



ISR(TIMER2_COMP_vect){//   
if (OCR2<220){
	PORT_OUT|=OUT_TRIAC;
	_delay_us(25);
	PORT_OUT&=~OUT_TRIAC;
	}
}

ISR(SIG_INTERRUPT0)//   .
{
	SFIOR|=_BV(PSR2);// Bit 0  PSR10: Prescaler Reset Timer/Counter1 and Timer/Counter0
	TCNT2=0;
	OCR2=power;
}

static void avr_init(void)
{
	//TCCR0=_BV(CS00);
	TCCR1B=(1<<CS10)|(1<<WGM12);// ctc mode
	
	MCUCR=(1<<ISC01)|(0<<ISC00);//1 1 The rising edge  //1 0 The falling edge of INT1 generates an interrupt request.
	GICR=_BV(INT0);//External Interrupt Request 0 Enable
	
	DDRZN=BITZN|SEG_GH;//    gh  
	DDRLED=0xFF;	

	DDR_VLAG|=OUT_VLAG;
	
	DDR_OUT=OUT_PIN;
	
	TIMSK=_BV(OCIE2);
	OCR1A=4000;// 1 
	OCR2=220;//156 ~= 10mSek, 220 -   , TCNT2     ,    ISR(SIG_INTERRUPT0)
	TCCR2=(1<<CS22)|(1<<CS21)|(0<<CS20);//  256
	
	sei();

    return;
}
//-------------------EEPROM-------------------------
static inline unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));
	EEAR = uiAddress;
	EECR |= (1<<EERE);
	return EEDR;
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		while(EECR & (1<<EEWE));
		cli();
		asm("wdr");//  
		EEAR = uiAddress;
		EEDR = ucData;
		EECR |= (1<<EEMWE);
		EECR |= (1<<EEWE);
		sei();
		}
}

void read_data_EEPROM(void)
{
unsigned char  *a, i, adr;
unsigned int crc=0;
	a=(unsigned char *)&setup;
	for( i=0, adr=ADR_EEP ; i<sizeof(setup); i++, a++, adr++){
		*a=EEPROM_read(adr);
		if (i<sizeof(setup)-2){
			crc+=*a;
			}
		}
	if ( crc!=setup.crc ) {
		eeprom_err=1;
		setup.correction_ds0=0;
		setup.correction_ds1=0;
		setup.porog=(uint16_t)(37.5*16);
		setup.AlarmT=(uint16_t)(40*16);
		setup.vlagnost=50;
		setup.time_lotok_pause=120;	//    ( 2 )
		setup.time_lotok_on=500;	//   0.1 
		setup.TimeOnVlagnost=50;	// 0.1 
		setup.TimePauseVlagnost=300;	// 0.1 
		}
	porog=setup.porog;
	Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//   
}

void EEPROM_save_parametr_all( void )
{
 unsigned char i, *p, adr;
 
	setup.crc=eeprom_err=0;
	p=(unsigned char *) &setup;
	for(i=0, adr=ADR_EEP; i<sizeof(setup) ; i++, p++, adr++){
		EEPROM_write( adr, *p );
		if (i<sizeof(setup)-2)
			setup.crc+=*p;
		}
}
//-------------END------EEPROM----------------------


//**********1wire************

static unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=PWIRE_0;//line down
	DDR_1wire|=PWIRE_1;//line down

	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~PWIRE_0;//line up through 1.25us
	DDR_1wire&=~PWIRE_1;//line up through 1.25us
	_delay_us(11);
	i=PIN_1wire;
	sei();
	_delay_us(47);
	return i;
}

static void readbyte(unsigned char *pw0) {
DDR_1wire&=~PWIRE_0;
DDR_1wire&=~PWIRE_1;
PORT_1wire&=~PWIRE_0;
PORT_1wire&=~PWIRE_1;
uint8_t rezult_0=0, rezult_1=0;
for(uint8_t i=0, r=1; i<8; i++){
	uint8_t p=readbit();
	if ( p & PWIRE_0 ) rezult_0|=r;
	if ( p & PWIRE_1 ) rezult_1|=r;
	r<<=1;	
	}
PORT_1wire|=out_1wire;
DDR_1wire |=out_1wire;
pw0[0]=rezult_0;
pw0[1]=rezult_1;
}

static void writebit0(void){
	cli();
	DDR_1wire|=PWIRE_0;//line down
	DDR_1wire|=PWIRE_1;//line down
	_delay_us(60);
	DDR_1wire&=~PWIRE_0;//line up 
	DDR_1wire&=~PWIRE_1;//line up 
	sei();
}

void writebit1(void){
	cli();
	DDR_1wire|=PWIRE_0;//line down
	DDR_1wire|=PWIRE_1;//line down
	_delay_us(3);
	DDR_1wire&=~PWIRE_0;//line up 
	DDR_1wire&=~PWIRE_1;//line up
	sei();
	_delay_us(58);
}

static void writebyte(unsigned char byte){
unsigned char i;
	//pullup_off();
	DDR_1wire&=~PWIRE_0;
	DDR_1wire&=~PWIRE_1;
	PORT_1wire&=~PWIRE_0;
	PORT_1wire&=~PWIRE_1;
	for(i=0; i<8; i++){
		if ( byte & _BV(0) )
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	PORT_1wire|=out_1wire;
	DDR_1wire |=out_1wire;
}

void detectPresence(void){
unsigned char i;
	//pullup_off();
	DDR_1wire&=~PWIRE_0;
	DDR_1wire&=~PWIRE_1;
	PORT_1wire&=~PWIRE_0;
	PORT_1wire&=~PWIRE_1;
	out_1wire=PWIRE_0|PWIRE_1;
	
	DDR_1wire|=PWIRE_0;
	DDR_1wire|=PWIRE_1;
	_delay_ms(0.48);
	
	cli();
	DDR_1wire&=~PWIRE_0;
	DDR_1wire&=~PWIRE_1;
	_delay_us(60);
	i=PIN_1wire;
	sei();
	
	if ( i & PWIRE_0 ) {
		out_1wire=PWIRE_1; 
		on_out_vlagnost=0;
		power=220; 
		PORT_OUT&=~OUT_TRIAC;
		PORT_OUT&=~OUT_ON_NAGREV; 
		PORT_OUT |= OUT_ALARM_2; 
		} 
	if ( i & PWIRE_1 ) {
		out_1wire&=~PWIRE_1; 
		on_out_vlagnost=0;
		PORT_VLAG&=~OUT_VLAG;
		}
	
	if ( out_1wire ){
		_delay_ms(0.42);
		i=PIN_1wire;
		if (!( i & PWIRE_0 )) {
			out_1wire=PWIRE_1; 
			on_out_vlagnost=0;
			power=220; 
			PORT_OUT&=~OUT_TRIAC;
			PORT_OUT&=~OUT_ON_NAGREV; 
			PORT_OUT |= OUT_ALARM_2;  
			}
		if (!( i & PWIRE_1 )) {
			out_1wire&=~PWIRE_1;
			on_out_vlagnost=0;
			PORT_VLAG&=~OUT_VLAG;
			}
		}
	if (out_1wire==0) state_wire=0;
	else{
	PORT_1wire|=out_1wire;
	DDR_1wire|=out_1wire;
	}
}
//*******end***1wire************


//**************************************************
void receive_t(void){

	if ( state_wire==0 )
	{
	state_wire=1;
	detectPresence();
	return;
	}
	
	if ( state_wire==1 )
	{
	state_wire=2;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x44);//CONVERT T [44h]
	time_wire=11;
	return;
	}
	
	if ( state_wire==2 )
	{
	if (time_wire>100) state_wire=3;
	return;
	}

	if ( state_wire==3 )
	{
	state_wire=4;
	detectPresence();
	return;
	}
	
	if ( state_wire==4 )
	{
	state_wire=5;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0xBE);//READ SCRATCHPAD [BEh]
	//readbyte(&temperature[0]);
	//readbyte(&temperature[2]);
	return;
	}
	if ( state_wire==5 )
	{
	state_wire=10;
	readbyte(&temperature[0]);
	readbyte(&temperature[2]);
	return;
	}
	
	if ( state_wire==10 )
	{
	state_wire=0;
	
	if ( out_1wire & PWIRE_1 ){
		Temp_DS2=( ((unsigned int)(temperature[3]<<8))|temperature[1] )+setup.correction_ds1;
		}
	
	
	if ( (out_1wire & PWIRE_0)==0 ) {
		alarm_T=3; 
		status_nagrev=0;
		power=220;
		PORT_OUT&=~OUT_ON_NAGREV;
		return;
		}
	
	Temperatura=( ((unsigned int)(temperature[2]<<8))|temperature[0] )+setup.correction_ds0;// 
	
	//static uint16_t T_old=130*16;
	if ( Temperatura > T_jmp+(uint16_t)(15*16) ) if ( T_jmp != 130*16 ) return; //    ,       .
	T_jmp=Temperatura;
	
	if ( Temperatura > setup.AlarmT ) 	//   ( )    (uint16_t) (40.5*16)
		{										
		PORT_OUT |= OUT_ALARM; 
		PORT_OUT |= OUT_ALARM_2;
		PORT_OUT&=~OUT_ON_NAGREV;
		power=220; 
		status_nagrev=4;
		}

//---------------------------------------------------------------------------------------------------------------------
#ifdef LOW_PWM
	//----------------------__----------------------------
	switch(status_nagrev)
	{
	case(0):
		if	( Temperatura >= porog-4*16 ) {//   -4    	
			Old_Temperatura=Temperatura;
			power=220;
			PORT_OUT&=~OUT_ON_NAGREV;
			status_nagrev=1;
			}
		else{
			power=1;//  
			PORT_OUT|=OUT_ON_NAGREV;
			}
		
		break;

	case(1):
		if ( Temperatura >= porog ){//   
			Old_Temperatura=0;
			power=220;
			PORT_OUT&=~OUT_ON_NAGREV;	
			status_nagrev=2;
			}
			else
			{
			if ( Temperatura > Old_Temperatura+1 )
				{
				Old_Temperatura=Temperatura;
				power=220;//
				PORT_OUT&=~OUT_ON_NAGREV;
				}
				else
				{
				power=1;
				PORT_OUT|=OUT_ON_NAGREV;
				}
			}
		break;
	
	case(2):
		if ( Temperatura < porog ) 	//       time_power_off  
			status_nagrev=3;		//   3    50% 
			else
		break;

	case(3):
		//   main()
		break;
	case(4)://  ,    
		if ( Temperatura < porog )
			{
			PORT_OUT &= ~OUT_ALARM;
			PORT_OUT|=OUT_ON_NAGREV;
			power=1;
			}
		else//	if ( Temperatura >= porog )
			{
			PORT_OUT |= OUT_ALARM;
			PORT_OUT&=~OUT_ON_NAGREV;
			power=220;
			}
		break;
	}
#else
//---------------------------------------------------------------------------------------------------------------------
	//------------------- ---------------------------------
	switch(status_nagrev)
	{
	case(0):
		if	( Temperatura >= porog-(uint16_t)4*16 ) {	
			Old_Temperatura=Temperatura;
			//power=120;// .. OCR2 max 155   (10mSek)
			tmp_power=70;// tmp_power -    , power -  ,      tmp_power,     
			PORT_OUT|=OUT_ON_NAGREV;
			status_nagrev=1;	//   -4    
			}
		else{
			tmp_power=power=1;//  
			PORT_OUT|=OUT_ON_NAGREV;
			}
		
		break;

	case(1):
		if ( Temperatura >= porog ){//   
			Old_Temperatura=0;
			tmp_power=70;
			power=220;
			PORT_OUT&=~OUT_ON_NAGREV;	
			status_nagrev=2;//        
			}
			else
			{
			if ( Temperatura > Old_Temperatura+1 )
				{
				if ( Temperatura > Old_Temperatura+2 ) 
					if ( tmp_power<100 ) tmp_power+=5;
				Old_Temperatura=Temperatura;
				power=130;//,   
				PORT_OUT&=~OUT_ON_NAGREV;
				}
				else
				{
				if (tmp_power>2) tmp_power-=2;//    ,  
				power=tmp_power;// 
				PORT_OUT|=OUT_ON_NAGREV;
				}
			}
		break;
	
	case(2):
		if ( Temperatura < porog ) 	//       time_power_off  
			status_nagrev=3;		//   3    50% 
			else
		break;

	case(3):
		if ( Temperatura <= porog )
			{
			#define T_NO_POWER	0	//    
			#define NAGREV_OFF	1	//   ,       
			#define T_BOTTOM	2	//  
			#define T_TOP		3
			
			if ( (power_flag==NAGREV_OFF)||(power_flag==T_NO_POWER) ) power=140;//    ,      
			power_flag=T_BOTTOM;
			uint8_t inc=1;
			if ( Temperatura+1 < porog ) inc=2;
			if ( Temperatura+2 < porog ) inc=5;//      
			
			if ( Temperatura != porog )
				if (tmp_power>inc) tmp_power-=inc;//  
			
			//power=tmp_power;//  main()
			PORT_OUT|=OUT_ON_NAGREV;
			}
		else  
		if ( Temperatura > porog )
			{//  
			if ( power_flag==T_BOTTOM ){
				if (tmp_power<100)//  ,   ,   ,     
					power=100;
				else 
				power=tmp_power;
				}
			power_flag=T_TOP;
			
			uint8_t inc=1;
			if ( Temperatura > porog+1 ) {
				power_flag=T_NO_POWER; 
				power=220;//  
				if ( Temperatura > porog+2 ) {inc=3;}
				}
			
			if (Temperatura>Old_Temperatura) {//      .
				if (tmp_power<145) tmp_power+=inc;
				}
			PORT_OUT&=~OUT_ON_NAGREV;
			}

		Old_Temperatura=Temperatura;
		break;
	case(4)://  ,    
		if ( Temperatura < porog )
			{
			PORT_OUT &= ~OUT_ALARM;
			PORT_OUT|=OUT_ON_NAGREV;
			power=1;
			}
		else//	if ( Temperatura >= porog )
			{
			PORT_OUT |= OUT_ALARM;
			PORT_OUT&=~OUT_ON_NAGREV;
			power=220;
			}
		break;
	}
#endif

	alarm_T=0;
	if ( Temperatura < (uint16_t)35*16 ) alarm_T=1;//   35 
	else
	if ( Temperatura > setup.AlarmT-(uint16_t)(0.5*16) ) alarm_T=2;//    1 
	
	if (eeprom_err) alarm_T=3;

	//----------------
	if ( out_1wire == (PWIRE_0|PWIRE_1) )
		{
		if (Temperatura >= 35*16 )//     35 
			{
			if (Temp_DS2 >= 24*16 )//     24 
				{
				uint8_t s,v;
				uint16_t T_table=(uint16_t)(43.5*16);//40*16;
				for(s=17; s!=0xFF; s--){//s=10
					if (Temperatura >= T_table)  break;
					T_table-=8;//0,5 
					}
				T_table=39*16;	
				for(v=30; v!=0xFF; v--){
					if (Temp_DS2 >= T_table)  break;
					T_table-=8;
					}
				Vlagnost=pgm_read_byte_near(&table_vl[s][v]);//  
				if (Vlagnost<=setup.vlagnost) on_out_vlagnost=1; else on_out_vlagnost=0;
				}
				else {on_out_vlagnost=1; Vlagnost=0;}//    ,   ,  
			}
			else {on_out_vlagnost=0; Vlagnost=0;}
		}
		else {on_out_vlagnost=0; Vlagnost=0;}//  ,  
//---------------------------------------------------------------	
	}
}

//**************************************
void result_in_bcd(int result)
{
    uint8_t dig_out=0;
	//bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;

	//while (result >= 1000) {
	// result -= 1000;
 	// dig_out ++;
	//}
	//bcd_num1=dig_out;
    //dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out;
	bcd_num4=result;
}
//**************************************
void t_in_bcd(signed int t, unsigned char pin_wire){

	 if ( !(pin_wire & out_1wire) ){
	 	led_buffer[0]=sG;
		led_buffer[1]=sG;
		led_buffer[2]=sG;
		}
		else
		{

		result_in_bcd( (t*5+2)/8 );
		
		if ( bcd_num2 ){ 
			led_buffer[0]=font[bcd_num2]; 
			}

		led_buffer[1]=font[bcd_num3]|sH; 
		led_buffer[2]=font[bcd_num4]; 
		}
}

//-------------------------------------
static void led_off(void)
{
	// 
#ifdef katod
	PORTZN |= ZN0;
	PORTZN |= ZN1;
	PORTZN |= ZN2;
	PORTZN &= ~SEG_G;
	PORTZN &= ~SEG_H;
	//PORTLED=0;
	PORTLED&=PWIRE_0|PWIRE_1;//xx00 0000
#else
	PORTZN &= ~ZN0;
	PORTZN &= ~ZN1;
	PORTZN &= ~ZN2;
	PORTZN |= SEG_G;
	PORTZN |= SEG_H;
	//PORTLED=0xFF;
	PORTLED|=~(PWIRE_0|PWIRE_1);//xx11 1111
#endif
}

//-------------------------------------
static void led_on(void)
{
#ifdef katod
	if ( znmesto==0 )	PORTZN &= ~ZN0;
	else
	if ( znmesto==1 )	PORTZN &= ~ZN1;
	else
	if ( znmesto==2 )	PORTZN &= ~ZN2;
	//PORTLED=led_buffer[znmesto];
	PORTLED|=led_buffer[znmesto]&(~(PWIRE_0|PWIRE_1));
	if ( led_buffer[znmesto] & _BV(6) ) PORTZN |= SEG_G;
	if ( led_buffer[znmesto] & _BV(7) ) PORTZN |= SEG_H;
#else
	if ( znmesto==0 )	PORTZN |= ZN0;
	else
	if ( znmesto==1 )	PORTZN |= ZN1;
	else
	if ( znmesto==2 )	PORTZN |= ZN2;
	//PORTLED=~led_buffer[znmesto];
	PORTLED&=~ ( led_buffer[znmesto]&(~(PWIRE_0|PWIRE_1)) );
	if ( led_buffer[znmesto] & _BV(6) ) PORTZN &= ~SEG_G;
	if ( led_buffer[znmesto] & _BV(7) ) PORTZN &= ~SEG_H;
#endif
}
//-------------------------------------
void skan_key(void){
// 4mSek
	
	PORTLED|=~(PWIRE_0|PWIRE_1);//PORTLED=0xFF;	//   1
	DDRLED&=PWIRE_0|PWIRE_1;//DDRLED=0;		// ,  .
	_delay_us(15);
	uint8_t pin=PINLED;
#ifdef katod
	PORTLED&=PWIRE_0|PWIRE_1;//PORTLED=0;
#else

#endif
	DDRLED|=~(PWIRE_0|PWIRE_1);//DDRLED=0xFF;
//--------------------------------------
#define KEY_PRESS(key)	((pin & (key))==0)
#define KEY_T		7
#define KEY_PLUS	4
#define KEY_MINUS	5
//---------------------------------------------------------------------------------------	
	//static uint8_t antdr, count_press, povtor;
	if ( KEY_PRESS(BTN_TIME_OFF ) || KEY_PRESS(BTN_DS2 ) || KEY_PRESS(BTN_TEMPER) ){//    
		if ( antdr>=pause_after_press[count_press] ) antdr=0;
		if (++antdr==2){
			
			if ( KEY_PRESS(BTN_TIME_OFF ) && KEY_PRESS(BTN_DS2 ) && KEY_PRESS(BTN_TEMPER) )
				key=1;//  
			else
			if ( KEY_PRESS(BTN_TEMPER)  &&  KEY_PRESS(BTN_DS2) )
				key=2;//   
			else
			if ( KEY_PRESS(BTN_TIME_OFF) && KEY_PRESS(BTN_DS2) )
				key=3;//     
			else	
			if ( KEY_PRESS(BTN_TIME_OFF) )
				key=KEY_MINUS;//   
			else
			if ( KEY_PRESS(BTN_DS2 ) )
				key=KEY_PLUS;// ds2
			else
			if ( KEY_PRESS(BTN_TEMPER ) )
				key=KEY_T;// 
			
			if (count_press<sizeof(pause_after_press)-1) count_press++;
			if (++povtor>=sizeof(pause_after_press)+35) inc=5;
			}
		}
		else{
		key=antdr=count_press=povtor=0;
		inc=1;
		}

//----------------------------
	static uint8_t antdr_swt;
	if ( KEY_PRESS(SWT_L_KONZEVIK)||KEY_PRESS(SWT_R_KONZEVIK) ){//  
		if (++antdr_swt>=125){//125-0.5 sek
			antdr_swt=0;
			if ( KEY_PRESS(SWT_L_KONZEVIK) ) swt_konzevik=1;
			if ( KEY_PRESS(SWT_R_KONZEVIK) ) swt_konzevik=2;
			}
		}
		else{
		swt_konzevik=antdr_swt=0;
		}
}
//-------------------------------------
void key_action(void){


	switch (state)
	{
    case (0):
		if ( key ) 
		{
		state=ST_INPUT_REG; 
		time_state=0;
		}
		break;
    case (ST_INPUT_REG):
		if ( key ){
			if (time_state>20){
				
				if (key==1) state=ST_COR;//  
				else
				if (key==2) state=ST_FORCE_POVOROT;//   
				else
				if (key==3) state=ST_MANUAL_MOVE; //     
				else
				if (key==KEY_MINUS) state=ST_TIM_OFF;//   
				else
				if (key==KEY_PLUS) state=ST_SET_VLAG;// ds2
				else
				if (key==KEY_T) state=ST_SET_T;// 
				else
				state=0;
				
				//show_vlagnost=0;
				}
				else
				{
				if (key==KEY_PLUS) show_vlagnost=1;	
				}
			}
			else {
			state=0;
			if (show_vlagnost) {time_state=0;	state=ST_SHOW_VLAGNOST;}
			}
		break;

	//--------------------------------------
	case (ST_STORE_EEP):
		
		EEPROM_save_parametr_all();
		
		state=0;
		break;
	//--------------------------------------
	case (ST_TIM_OFF):
		if (key==0) { time_state=0; tmp_uint16=setup.time_lotok_pause; state=ST_TIM_OFF_1;}	//     
		break;
	
	case (ST_TIM_OFF_1):	//      10
		if (key==KEY_PLUS){
			if ( (tmp_uint16+=inc)>599) tmp_uint16=0;
			time_state=0;
			key=0;
			}
		if (key==KEY_MINUS){
			if ( (tmp_uint16-=inc)>599) tmp_uint16=599;
			time_state=0;
			key=0;
			}
		if (time_state>40) {// 4  ,     eeprom
			setup.time_lotok_pause=	tmp_uint16;
			state=ST_STORE_EEP;
			}
		break;
	
	//-------------------------------------------------
	case (ST_MANUAL_MOVE):
		if (key==0) { time_state=0; tmp_uint16=0; state=ST_MANUAL_MOVE_1;}//    
		break;
	case (ST_MANUAL_MOVE_1)://     12
		if (key==KEY_T) {state=ST_MANUAL_MOVE_2; time_state=0;}//  KEY_T     
		
		if (time_state>250) state=show_vlagnost=0;// 25  , 
		
		if (key==KEY_PLUS){
			state_motor=1;// 
			time_state=0;
			}
		else
		if (key==KEY_MINUS){
			state_motor=2;//
			time_state=0;
			}
		else 
		if (state_motor<3) //  
			state_motor=3;//   
		
		revers=1;//        .
		break;
	case (ST_MANUAL_MOVE_2)://13
		if (key==0) {
				tmp_uint16=0;
				state=ST_MANUAL_MOVE_1;
				}
		if (time_state>30) {//  KEY_T    3,     
			Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  ,        
			setup.time_lotok_on=	tmp_uint16;
			show_vlagnost=0;
			state=ST_STORE_EEP;
			}
		break;
	
	case (ST_FORCE_POVOROT)://    14
		#if defined(AKTUATOR)
		Time_Motor=1;
		#else
		if ( (PORT_OUT & OUT_MOTOR)==0 )//   
			Time_Motor=1;
		#endif
		state=0;
		break;

	//------------------------------------------------------------
	case (ST_COR)://  15
		if (key==0){
			state=ST_COR_1; 
			time_state=0;
			if (setup.correction_ds0>0)
				tmp_int16=(setup.correction_ds0*5+2)/8; 
				else
				tmp_int16=(setup.correction_ds0*5-2)/8;
			}
			else
			if (time_state>40)
			{
			state=ST_COR_IN_DS2; 
			}
		break;
	case (ST_COR_IN_DS2)://  15
		if (key==0){
			state=ST_COR_2; 
			time_state=0;
			if (setup.correction_ds1>0)
				tmp_int16=(setup.correction_ds1*5+2)/8; 
				else
				tmp_int16=(setup.correction_ds1*5-2)/8;
			}
		break;
	case (ST_COR_1):	//    
	case (ST_COR_2):
		if (key==KEY_PLUS){
			if (++tmp_int16>99) tmp_int16=0;
			time_state=0;
			key=0;
			}
		if (key==KEY_MINUS){
			if (--tmp_int16<-99) tmp_int16=0;
			time_state=0;
			key=0;
			}
		if (time_state>40) {// 4  ,     eeprom
			int16_t *p;
			if (state==ST_COR_1) p=&setup.correction_ds0; else p=&setup.correction_ds1;
			if (tmp_int16>0)
				*p=(tmp_int16*8+2)/5;
				else
				*p=(tmp_int16*8-2)/5;
			state=ST_STORE_EEP;
			}
		break;
	
	//------ --ds0--------
	case (ST_SET_T)://  15
		if (key==0){
			state=ST_SET_T_1; 
			time_state=0;
			tmp_uint16=(porog*5+2)/8; 
			tmp_int16=(uint16_t)((setup.AlarmT*5+2)/8-5);
			}
			else
			if (time_state>40)
			{
			state=ST_SET_T_ALARM; 
			}
		break;
	case (ST_SET_T_1):	//  
		if ((key==KEY_T)||(key==KEY_PLUS)){
			if (++tmp_uint16> tmp_int16 ) tmp_uint16=350;
			time_state=0;
			key=0;
			}
		if (key==KEY_MINUS){
			if (--tmp_uint16<350) tmp_uint16=tmp_int16;
			time_state=0;
			key=0;
			}
		if (time_state>40) {// 4  ,     eeprom
			setup.porog=porog=(tmp_uint16*8+2)/5;
			status_nagrev=0;
			state=ST_STORE_EEP;
			}
		break;
	case (ST_SET_T_ALARM): //   
		if (key==0) {tmp_uint16=(setup.AlarmT*5+2)/8; time_state=0; state=ST_SET_T_ALARM_1;}
		break;
	case (ST_SET_T_ALARM_1):	//   
		if ((key==KEY_T)||(key==KEY_PLUS)){
			if (++tmp_uint16>450) tmp_uint16=390;
			time_state=0;
			key=0;
			}
		if (key==KEY_MINUS){
			if (--tmp_uint16<390) tmp_uint16=450;
			time_state=0;
			key=0;
			}
		if (time_state>40) {// 4  ,     eeprom
			setup.AlarmT=(tmp_uint16*8+2)/5;
			state=ST_STORE_EEP;
			}
		break;

	//---------------------ds2--------------------------------------
	case (ST_SET_VLAG)://8
		if (key==0) { time_state=0; tmp_uint16=setup.vlagnost; state=ST_SET_VLAG_POROG;}//  2  
		else
		if (time_state>35){
			state=ST_SET_VLAG_T_ON;//ST_SET_VLAG_PAUSE;
			}
		break;
		
	case (ST_SET_VLAG_POROG)://  2   
		if ((key==KEY_T)||(key==KEY_PLUS)){
			if (++tmp_uint16>97) tmp_uint16=17;
			time_state=0;
			key=0;
			}
		if (key==KEY_MINUS){
			if (--tmp_uint16<17) tmp_uint16=97;
			time_state=0;
			key=0;
			}
		if (time_state>40) {// 4  ,     eeprom
			setup.vlagnost=tmp_uint16;
			state=ST_STORE_EEP;
			}
		break;
	//-------------------------------------------------------------	
	case (ST_SET_VLAG_T_ON)://PAU 18
		if (key==0) { time_state=0; tmp_uint16=setup.TimeOnVlagnost/10; state=ST_SET_VLAG_T_ON_1;}
		else
		if (time_state>50){
			state=ST_SET_VLAG_PAUSE;//ST_SET_VLAG_PAUSE;
			}
		break;
	//-------------------------------------------------------------	
	case (ST_SET_VLAG_PAUSE)://PAU 18
		if (key==0) { time_state=0; tmp_uint16=setup.TimePauseVlagnost/10; state=ST_SET_VLAG_PAUSE_1;}
		break;
	
	case (ST_SET_VLAG_T_ON_1):
	case (ST_SET_VLAG_PAUSE_1)://pausa 19
		if ((key==KEY_T)||(key==KEY_PLUS)){
			if ( (tmp_uint16+=inc)>200 ) tmp_uint16=0;
			time_state=0;
			key=0;
			}
		if (key==KEY_MINUS){
			if ( (tmp_uint16-=inc)>200) tmp_uint16=200;
			time_state=0;
			key=0;
			}
		if (time_state>40) {// 4  ,     eeprom
			int16_t *p;
			if (state==ST_SET_VLAG_T_ON_1) p=&setup.TimeOnVlagnost; else p=&setup.TimePauseVlagnost;
			*p=tmp_uint16*10;
			state=ST_STORE_EEP;
			}
		break;
	//-----------------------------------------------------------
	case (ST_SHOW_VLAGNOST)://2 ds
		if  (time_state>200) {show_vlagnost=state=0;}
		if (key) 
		{
		if (key==KEY_PLUS) {
			if (++show_vlagnost==3){
				show_vlagnost=state=0;
				}
			key=time_state=0;
			}
			else
			show_vlagnost=state=0;
		}
		break;
	default:
		state=0;
		break;
	//*/
	}
}

//-------------------------------------


//-------------------------------------
void data_led(void)
{
unsigned char i;

for(i=0;i<sizeof(led_buffer);i++)
	led_buffer[i]=0;


	switch (state)
	{
    /*case (0):
    case (1):
	case (2):
		if ( time_flag & _BV(_crc_error) ){
			led_buffer[0]=font[f_e];
			led_buffer[1]=font[f_e];
			led_buffer[2]=font[f_P];
			}
			else
		t_in_bcd(Temperatura*10>>4,PWIRE_0);
		break;*/

    case (ST_SET_T):
		led_buffer[0]=font[f_y];
		led_buffer[1]=font[f_C];
		led_buffer[2]=font[f_t];
		break;
	case (ST_SET_T_ALARM):
		led_buffer[0]=font[f_a];
		led_buffer[1]=font[8];
		led_buffer[2]=font[f_P]|sH;
		break;
		
	case (ST_TIM_OFF):
		led_buffer[0]=font[0];
		led_buffer[1]=font[f_F];
		led_buffer[2]=font[f_F];
		break;
	
	case (ST_SET_VLAG):
		led_buffer[0]=font[8];//sC|sD|sE;//u
		led_buffer[1]=sE|sD|sF;
		led_buffer[2]=font[f_a];//sF|sE|sA|sH;
		//led_buffer[0]=font[f_d];
		//led_buffer[1]=font[5];
		//led_buffer[2]=font[2];
		break;
	case (ST_MANUAL_MOVE):
		led_buffer[0]=font[f_P];
		led_buffer[1]=font[f_y];
		led_buffer[2]=font[4]|sH;
		break;
	case (ST_SET_VLAG_T_ON)://  
		led_buffer[0]=font[f_t]|sH;
		led_buffer[1]=font[f_o]; 
		led_buffer[2]=font[f_n];
		break;
	case (ST_SET_VLAG_PAUSE)://  
		led_buffer[0]=font[f_P];
		led_buffer[1]=font[f_a]; 
		led_buffer[2]=font[f_U];
		break;
	case (ST_COR)://   
		led_buffer[0]=font[f_C];
		led_buffer[1]=font[0];
		led_buffer[2]=font[f_P]|sH;
		break;
	case (ST_COR_IN_DS2)://    ds2
		led_buffer[0]=sG;
		led_buffer[1]=font[2];
		led_buffer[2]=sG;
		break;
	
	case (ST_SET_T_1)://  
	case (ST_SET_T_ALARM_1):
	//case (ST_SET_VLAG_POROG)://  
		if ( !blank )
		{
		result_in_bcd(tmp_uint16);
		led_buffer[0]=font[bcd_num2];
		led_buffer[1]=font[bcd_num3]|sH; 
		led_buffer[2]=font[bcd_num4]; 
		}
		break;
	case (ST_SET_VLAG_POROG)://  
		if ( !blank )
		{
		result_in_bcd(tmp_uint16);
		led_buffer[0]=font[bcd_num3];
		led_buffer[1]=font[bcd_num4]; 
		}
		led_buffer[2]=sB|sE; 
		break;
	
	case (ST_MANUAL_MOVE_1)://  
		#if defined (AKTUATOR)
		led_buffer[1]=sA|sD;
		if (  PORT_OUT & OUT_MOTOR ) 
			led_buffer[0]=font[1];//sA|sF|sE|sD;
			else
			led_buffer[2]=font[0];//sA|sB|sC|sD;
		break;
		#endif
	case (ST_SET_VLAG_T_ON_1)://    
	case (ST_SET_VLAG_PAUSE_1)://  
		if ( !blank )
		{
		if (state==ST_MANUAL_MOVE_1)
		result_in_bcd(tmp_uint16/10);
		else
		result_in_bcd(tmp_uint16);
		led_buffer[0]=font[bcd_num2];
		led_buffer[1]=font[bcd_num3]; 
		led_buffer[2]=font[bcd_num4];
		}	
		break;
	case (ST_MANUAL_MOVE_2):
		break;
	
	case (ST_TIM_OFF_1):	//    
		if ( !blank )
		{
		led_buffer[0]=font[tmp_uint16/60]|sH;
		result_in_bcd(tmp_uint16%60);
		led_buffer[1]=font[bcd_num3]; 
		led_buffer[2]=font[bcd_num4]; 
		}
		break;
	
	case (ST_COR_1)://   
	case (ST_COR_2):
		if ( !blank )
		{
		if (tmp_int16<0){
			result_in_bcd(tmp_int16*-1);
			led_buffer[0]=sG;
			}
			else
			result_in_bcd(tmp_int16);
		led_buffer[1]=font[bcd_num3]|sH; 
		led_buffer[2]=font[bcd_num4]; 
		}
		break;
	
	case (ST_SHOW_VLAGNOST)://
		if (show_vlagnost==1){
			result_in_bcd(Vlagnost);
			if (Vlagnost<100){
				led_buffer[0]=font[bcd_num3];
				led_buffer[1]=font[bcd_num4]; 
				led_buffer[2]=sB|sE|sH;
				}else{
				led_buffer[0]=font[bcd_num2];
				led_buffer[1]=font[bcd_num3];
				led_buffer[2]=font[bcd_num4]|sH;
				}
			}else{
			t_in_bcd(Temp_DS2,PWIRE_1);
			led_buffer[2]|=sH;
			}
		break;

    default:
		if ( eeprom_err ){
			led_buffer[0]=font[f_e];
			led_buffer[1]=font[f_e];
			led_buffer[2]=font[f_P];
			}
			else
		t_in_bcd(Temperatura,PWIRE_0);
		break;
	}

}
//-------------------------------------


int main(void)
{
uint8_t tim_led=4, tim_0_01_sek=10, tim_motor=50, spolzanie_swt=1, st_motor_on=0, tim_0_1_sek=100;
	
	{
	uint8_t p=pgm_read_byte_near(&osccal);
	if ( p!=0xFF )
		OSCCAL=p;// adress = 0x5C
	}
	
	cli();
	avr_init();
	
	read_data_EEPROM();

	detectPresence();
	if (out_1wire){
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
		writebyte(0);//	TH
		writebyte(0);//	TL
		writebyte(0x7F);//	20 Statys 10bit //writebyte(0x60);//	Statys 12bit byte 4 Configuration Register* 0x7F - 12 bit 750mSek; 1F-9bit 94msek
		}
	
	// 
	cli();
//#if defined (__AVR_ATmega8__)
	WDTCR=(1<<WDCE)|(1<<WDE);
	WDTCR=(1<<WDP0)|(1<<WDE);//32mSek
//#endif
	asm("wdr");//  
	sei();
	
	power=220;
	
while(1)
{
if (TIFR & _BV(OCF1A)) // 0.001 sek
	{
	TIFR = _BV(OCF1A);
	
	if ( --tim_led==0 )// 
		{
		tim_led=4;
		led_off();//  
		asm("wdr");//  
		skan_key();
		key_action();
		if (++znmesto<3)
			{
			led_on();// . 
			}
			else
			{
			znmesto=0xFF;
			tim_led=1;// 
			data_led();
			receive_t();//
			}
		
		}
	
	//----------=----------------------0.01-Sek---------------------------------------
	if ( --tim_0_01_sek==0 )	//0.01sek
		{
		tim_0_01_sek=10;
		
		//-----------------------------------------------------------------------
		#ifdef LOW_PWM
		//---------------__-----------------
		if ( status_nagrev == 3 )
		{ 
		static uint8_t   delay_inc_dec, power_on;
		static uint8_t  time_power=1, time_power_off=30;
		if (++delay_inc_dec==20) delay_inc_dec=0;// 0.2 sek
		
		if ( Temperatura > porog )
			{
			if (time_power_off<255) 
				if(delay_inc_dec==0) time_power_off++;
			power=220;
			PORT_OUT&=~OUT_ON_NAGREV;
			}
		else
			{//   ,  
			uint8_t dec=1;
			if ( Temperatura < porog ){
				if ( Temperatura+2 < porog ) dec=2;
				if(delay_inc_dec==0)
					{
					if (time_power_off>=dec) 
						time_power_off-=dec;
						else
						time_power_off=0;
					}
				}
			
			if (--time_power==0){
				if ( time_power_off <= 1 ) power_on=0;//  ,    .
				
				if (power_on)
					{//    
					power_on=0;
					time_power=time_power_off;
					power=220;
					PORT_OUT&=~OUT_ON_NAGREV;
					}
					else
					{
					time_power=30;
					power_on=1;
					power=1;
					PORT_OUT|=OUT_ON_NAGREV;
					}
				}
			
			}
		}
		#else
		//-----------------------------------------------------------------------
		
		//------__----------
		if (status_nagrev==3)
		{
		if ( power_flag==T_TOP ){
			if ( power<145 ) power++; else {power=220; power_flag=NAGREV_OFF;}
			}
		else
		if ( power_flag==T_BOTTOM ){	//  power  tmp_power 
				uint8_t p=power;
				if ( p>tmp_power ) p--; 
				else 
				if ( p<tmp_power ) p++; 
				power=p;	
			}
		}
		#endif
		//-------___------------
		if (--time_blank==0)
			{
			if ( blank )
				{//   
				blank=0;
				time_blank=50;//0.5sek
				}
			else
				{
				blank=1;
				time_blank=20;
				}
			}
		if ( antdr ){
				blank=0;
				time_blank=10;
				}
		}
	
	//------------------------------1mSek----------------------------------
	#if defined (REVERS_RELE)
	if (state_motor==0){ //  
		tim_motor=100;
		st_motor_on=0;// 0     1- , 2-
		}
		else
		if (state_motor==1){//  
			if (st_motor_on==0)
				{
				PORT_OUT &= ~OUT_MOTOR_REVERS;
				PORT_OUT |= OUT_MOTOR;
				tim_0_1_sek=100;//  ()   
				st_motor_on=1;
				spolzanie_swt=1;
				}
			}
		else
		if (state_motor==2){//  + 
			if (st_motor_on==0)
				{
				PORT_OUT |= OUT_MOTOR_REVERS;
				if (--tim_motor==0){
					PORT_OUT |= OUT_MOTOR;
					tim_0_1_sek=100;
					st_motor_on=2;
					spolzanie_swt=2;
					}
				}
			}
		else
		if (state_motor==3){//
			PORT_OUT &= ~OUT_MOTOR;
			tim_motor=100;
			st_motor_on=0;
			state_motor=4;
			}
		else
		if (state_motor==4){//
			if ( PORT_OUT & OUT_MOTOR_REVERS ) 
				{
				if (--tim_motor==0){//100  
					PORT_OUT &= ~OUT_MOTOR_REVERS;
					state_motor=0;
					}
				}else{
				PORT_OUT &= ~OUT_MOTOR_REVERS;//  ,   .    
				state_motor=0;
				}
			}
		else
		state_motor=0;
	//----------------------------------------------------------------------------------------------
	#elif defined (AKTUATOR) // 
	//----------------------------------------------------------------------------------------------
	if (state_motor==1){//  
		PORT_OUT |= OUT_MOTOR;
		}
		else
	if (state_motor==2){//  + 
		PORT_OUT &= ~OUT_MOTOR;
		}
	
	//----------------------------------------------------------------------------------------------
	#else	//  
	//----------------------------------------------------------------------------------------------
	if (state_motor==0){ //  
		PORT_OUT &= ~OUT_MOTOR;
		PORT_OUT &= ~OUT_MOTOR_REVERS;
		st_motor_on=0;// 0     1- , 2-
		}
		else
		if (state_motor==1){//  
			if (st_motor_on==0)
				{
				PORT_OUT |= OUT_MOTOR;
				tim_0_1_sek=100;//  ()   
				st_motor_on=1;
				spolzanie_swt=1;
				}
			}
		else
		if (state_motor==2){//  + 
			if (st_motor_on==0)
				{
				PORT_OUT |= OUT_MOTOR_REVERS;
				tim_0_1_sek=100;
				st_motor_on=2;
				spolzanie_swt=2;
				}
			}
		else
		if (state_motor==3){//
			state_motor=0;
			}
		else
		state_motor=0;
	#endif
	
	//--------------------------------0.1_Sek------------------------------------
	if ( --tim_0_1_sek==0 )	//0.1sek
		{
		tim_0_1_sek=100;
		
		time_wire--;	//   
		time_state++;	//      
		
		//-------    ---------------------
		if (on_out_vlagnost){
			if (--time_vlagnost<=0){
				if (PORT_VLAG & OUT_VLAG){
					time_vlagnost=setup.TimePauseVlagnost;
					if (time_vlagnost) PORT_VLAG&=~OUT_VLAG;//      ,   
					}else{
					PORT_VLAG|=OUT_VLAG;
					time_vlagnost=setup.TimeOnVlagnost;
					}
				}
			}else{
			time_vlagnost=0;
			PORT_VLAG&=~OUT_VLAG;
			}
		
		//-------      35..40.5 --------
		if ( alarm_T )
			{
			if ( --time_alarm == 0 )
				{
				if ( PORT_OUT & INDIKATION_ALARM ){// 
					PORT_OUT &= ~INDIKATION_ALARM;
					if ( alarm_T == 1 ) time_alarm=20;
						else time_alarm=5;
					}
					else{
					PORT_OUT |= INDIKATION_ALARM;
					if ( alarm_T == 3 ) time_alarm=15;
						else time_alarm=5;
					}
				}
			}
			else {time_alarm=1; PORT_OUT &= ~INDIKATION_ALARM;}
		
		#if defined(AKTUATOR) // 
		if ( --Time_Motor<=0 ){
			//PORT_OUT^=OUT_MOTOR;
			if (  PORT_OUT & OUT_MOTOR ){
				state_motor=2;//  ,     state_motor
				}
				else{
				state_motor=1;
				}
			if (setup.time_lotok_pause)
				Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  
				else
				state_motor=2;
			}
		#else
		//---------- -----------
		if (state==ST_MANUAL_MOVE_1)
			{
			if (st_motor_on==1){
				tmp_uint16++;
				}
			else
			if (st_motor_on==2){
				if (tmp_uint16) tmp_uint16--; 
				}
			}
		else
		{
		//---------- -------------
		if (swt_konzevik){
			#ifdef REVERS_RELE
			if (  PORT_OUT & OUT_MOTOR ) //  
			#else
			if ( (PORT_OUT & OUT_MOTOR)||(PORT_OUT & OUT_MOTOR_REVERS) ) //  
			#endif
				if (spolzanie_swt==0) //     (  spolzanie_swt>0)
					Time_Motor=1; // .
			}
			else
			spolzanie_swt=0;
			
		if ( --Time_Motor<=0 ){
			if (swt_konzevik==1) revers=0;//   ( ) -   
			if (swt_konzevik==2) revers=1;
			//if ( (state_motor==1)||(state_motor==2))//   
			#ifdef REVERS_RELE
			if (  PORT_OUT & OUT_MOTOR ) //  
			#else
			if ( (PORT_OUT & OUT_MOTOR)||(PORT_OUT & OUT_MOTOR_REVERS) ) //  
			#endif
				{
				state_motor=3;//
				Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  
				}
				else
				{
				// 
				#ifdef LOTOK_ONE_SW
				//   
				state_motor=1+revers;
				revers^=_BV(0);
				Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//   ( )
				#else
				//   (    )
				if (setup.time_lotok_on){//    
					state_motor=1+revers;
					revers^=_BV(0);
					Time_Motor=setup.time_lotok_on;
					}
					else{//    ,    
					Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  
					state_motor=3;//
					}
				#endif
				}
			}
		}
		#endif
		//----------------------------------------
		}

	//-------------------------------------------------------------
	}
}

}

